<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::gate_exp&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1gate__exp.html">gate_exp</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1gate__exp-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::gate_exp&lt; T &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ae29287d727467b077fd9041e6581ffa8"><td class="memItemLeft" align="right" valign="top"><a id="ae29287d727467b077fd9041e6581ffa8"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>gate_exp</b> (T &amp;exp_)</td></tr>
<tr class="separator:ae29287d727467b077fd9041e6581ffa8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3cfd6484826164ccef411dedbafe9763"><td class="memItemLeft" align="right" valign="top"><a id="a3cfd6484826164ccef411dedbafe9763"></a>
const qc_scalar_type&#160;</td><td class="memItemRight" valign="bottom"><b>operator()</b> (long r, long c) const</td></tr>
<tr class="separator:a3cfd6484826164ccef411dedbafe9763"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa9cbb00e017a4817888ba366787a47f6"><td class="memItemLeft" align="right" valign="top"><a id="aa9cbb00e017a4817888ba366787a47f6"></a>
const <a class="el" href="classdlib_1_1matrix.html">matrix</a>&lt; qc_scalar_type &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>mat</b> () const</td></tr>
<tr class="separator:aa9cbb00e017a4817888ba366787a47f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a510f9075a5cfb1beb904984de33191cf"><td class="memItemLeft" align="right" valign="top"><a id="a510f9075a5cfb1beb904984de33191cf"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>apply_gate_to</b> (<a class="el" href="classdlib_1_1quantum__register.html">quantum_register</a> &amp;reg) const</td></tr>
<tr class="separator:a510f9075a5cfb1beb904984de33191cf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0322a19e97605fefc0cb3ca8dd097baf"><td class="memTemplParams" colspan="2"><a id="a0322a19e97605fefc0cb3ca8dd097baf"></a>
template&lt;typename exp &gt; </td></tr>
<tr class="memitem:a0322a19e97605fefc0cb3ca8dd097baf"><td class="memTemplItemLeft" align="right" valign="top">qc_scalar_type&#160;</td><td class="memTemplItemRight" valign="bottom"><b>compute_state_element</b> (const <a class="el" href="classdlib_1_1matrix__exp.html">matrix_exp</a>&lt; exp &gt; &amp;reg, long row_idx) const</td></tr>
<tr class="separator:a0322a19e97605fefc0cb3ca8dd097baf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a63de49e8e7338cfc5ea8a85d3cc75399"><td class="memItemLeft" align="right" valign="top"><a id="a63de49e8e7338cfc5ea8a85d3cc75399"></a>
const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>ref</b> () const</td></tr>
<tr class="separator:a63de49e8e7338cfc5ea8a85d3cc75399"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr class="memitem:a9d77602a883a39dde10cb2843651fd9f"><td class="memItemLeft" align="right" valign="top"><a id="a9d77602a883a39dde10cb2843651fd9f"></a>
static const long&#160;</td><td class="memItemRight" valign="bottom"><b>num_bits</b> = <a class="el" href="structdlib_1_1gate__traits.html">gate_traits</a>&lt;T&gt;::num_bits</td></tr>
<tr class="separator:a9d77602a883a39dde10cb2843651fd9f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a986edc81a42217a69e24680c45b2a043"><td class="memItemLeft" align="right" valign="top"><a id="a986edc81a42217a69e24680c45b2a043"></a>
static const long&#160;</td><td class="memItemRight" valign="bottom"><b>dims</b> = <a class="el" href="structdlib_1_1gate__traits.html">gate_traits</a>&lt;T&gt;::dims</td></tr>
<tr class="separator:a986edc81a42217a69e24680c45b2a043"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a68148427d68cbf81364f1032cf1e1a1a"><td class="memItemLeft" align="right" valign="top"><a id="a68148427d68cbf81364f1032cf1e1a1a"></a>
T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>exp</b></td></tr>
<tr class="separator:a68148427d68cbf81364f1032cf1e1a1a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="quantum__computing_2quantum__computing_8h_source.html">quantum_computing/quantum_computing.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
